# This file was generated by mettle.genes.db.GenPy3 [ver 2.2] on Thu Sep  8 08:33:22 2022
#  Target Database = postgresql
#
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_fura.db.tables.site_cfg_key import tSiteCfgKey

class dSiteCfgDeleteOne:
    __slots__ = ("_dbcon", "_dbstmnt", "irec")

    def __init__(self, dbcon: mettle.db.IAConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.irec     = tSiteCfgKey()

    async def __aenter__(self):
        """
        With statement enter.
        """
        return self

    async def __aexit__(self, type, value, traceback):
        """
        With statement exit.
        """
        await self._destroy()

    async def _destroy(self):
        if self._dbstmnt:
            await self._dbstmnt.destroy()
            self._dbstmnt = None

    async def exec_deft(self,
                        site_id: int,
                        id: str) -> "dSiteCfgDeleteOne":
        """
        Execute the query by setting all the inputs.

        :param site_id: int
        :param id: str
        :return: Self for convenience.
        """
        self.irec.site_id = site_id
        self.irec.id = id

        return await self.exec()

    async def exec(self, irec: tSiteCfgKey = None) -> "dSiteCfgDeleteOne":
        """
        Execute the query, optionally passing in the input rec.

        :param irec:
        :return: Self for convenience.
        """
        if irec:
            self.irec._copy_from(irec)

        await self._destroy()

        self._dbstmnt = await self._dbcon.statement("SiteCfgDeleteOne", self._dbcon.STMNT_TYPE_CUD)

        self._dbstmnt.sql("""delete from
  fura.SiteCfg
where
  site_id = :site_id and
  id = :id""")

        self._dbstmnt.bind_in("site_id", self.irec.site_id, int, 4)
        self._dbstmnt.bind_in("id", self.irec.id, str, 256)

        await self._dbcon.execute(self._dbstmnt)

        if irec:
            irec._copy_from(self.irec)

        return self

