# This file was generated by mettle.genes.db.GenPy3 [ver 2.2] on Thu Sep  8 08:33:22 2022
#  Target Database = postgresql
#
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_fura.db.tables.isite_id_by_code import iSiteIdByCode
from bs_fura.db.tables.osite_id_by_code import oSiteIdByCode

class dSiteIdByCode:
    __slots__ = ("_dbcon", "_dbstmnt", "irec", "orec")

    def __init__(self, dbcon: mettle.db.IAConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.irec     = iSiteIdByCode()
        self.orec     = None

    async def __aenter__(self):
        """
        With statement enter.
        """
        return self

    async def __aexit__(self, type, value, traceback):
        """
        With statement exit.
        """
        await self._destroy()

    async def _destroy(self):
        if self._dbstmnt:
            await self._dbstmnt.destroy()
            self._dbstmnt = None

    async def exec_deft(self,
                        code: str) -> "dSiteIdByCode":
        """
        Execute the query by setting all the inputs.

        :param code: str
        :return: Self for convenience.
        """
        self.irec.code = code

        return await self.exec()

    async def exec(self, irec: iSiteIdByCode = None) -> "dSiteIdByCode":
        """
        Execute the query, optionally passing in the input rec.

        :param irec:
        :return: Self for convenience.
        """
        if irec:
            self.irec._copy_from(irec)

        await self._destroy()

        self._dbstmnt = await self._dbcon.statement("SiteIdByCode", self._dbcon.STMNT_TYPE_READ)

        self._dbstmnt.sql("""select
  s.id
from
  fura.site s
where
  s.code = :code""")

        self._dbstmnt.bind_in("code", self.irec.code, str)

        self._dbstmnt.bind_out("siteId", int, 4)

        await self._dbcon.execute(self._dbstmnt)

        if irec:
            irec._copy_from(self.irec)

        return self

    async def fetch(self, must_exist: bool = False) -> bool:
        """
        Fetches the next row from the executed query.

        :param must_exist:
        :return: True if a row was fetched, else False.
        """
        if not await self._dbcon.fetch(self._dbstmnt):
            if must_exist:
                raise mettle.lib.xMettle(f"Record not found: [table:Site, proc:IdByCode, row:{self.irec}]", err_code=mettle.lib.xMettle.eCode.DBNotFound)
            return False

        self.orec = oSiteIdByCode()

        self.orec.site_id = self._dbstmnt.result[0]

        return True

    async def fetch_iter(self) -> oSiteIdByCode:
        """
        Yield all the rows one at a time.

        :return: Iterator for output rows
        """
        while await self.fetch():
            yield self.orec

    async def fetch_all(self, out_list: oSiteIdByCode.List, clear_list: bool = True) -> int:
        """
        Fetch all the rows into the specified list and return the list count.

        :param out_list:
        :param clear_list:
        :return: Number of rows fetched.
        """
        if clear_list:
            out_list.clear()

        while await self.fetch():
            out_list.append(self.orec)

        return len(out_list)

